var CountryDicer = (function(jumpCallback, showCountrySelectorCallback) {

    var jumpCallback;
    var showCountrySelectorCallback;

    //var API_KEY = '8012d64746b742d092e3cba81adf17d6';
    var API_KEY = 'a7e543270ab349e8926eca5ea30474ce';
    var trigger;

    var analysis = {
        inCookie: '',
        detected: {
            ip: '',
            country: ''
        },
        decision: ''
    };

    function getRequest(url, callback) {
        var jsonData = {};
        var xhr = new XMLHttpRequest();

        xhr.onreadystatechange = function() {
            if (this.readyState === 4 && this.status >= 200 && this.status < 300) {
                callback(JSON.parse(this.responseText));
            } else if (this.readyState === 4) {
                console.log('fallo en xhr', this);
            }
        };
        xhr.withCredentials = true;
        xhr.open('GET', url);
        xhr.setRequestHeader('Accept', 'application/json');
        xhr.send();
    }

    function setup(_jumpCallback, _showCountrySelectorCallback) {
        jumpCallback = _jumpCallback;
        showCountrySelectorCallback = _showCountrySelectorCallback;
    }

    function url(command) {
        return 'https://api.ipgeolocation.io/' + command + '?apiKey=' + API_KEY;
    }

    function dice() {
        pullThePin();
        var country = getCountry();
        if (country) {
            analysis.inCookie = country;
            analysis.decision = 'saltar';
            putThePinBack();
            jumpCallback(country);
        } else {
            analysis.inCookie = 'none';
            check();
        }
    }

    function putThePinBack() {
        console.log('put the pin back');
        clearTimeout(trigger);
    }

    function pullThePin() {
        console.log('pull the pin');
        trigger = setTimeout(function() {
            console.log('triggered!!');
            showCountrySelectorCallback();
        }, 5000);

    }

    function badCountry(country) {
        return !['ar','us','es'].includes(country);
    }

    function check() {
        console.log('check');
        getRequest(url('getip'), function(data) {
            console.log('ip aquired', data);
            analysis.detected.ip = data.ip;
            getRequest(url('ipgeo') + '&ip=' + data.ip, function(data) {
                console.log('country acquired', data);
                var country = data.country_code2.toLowerCase();
                analysis.detected.country = country;
                putThePinBack();
                if (badCountry(country)) {
                    analysis.decision = 'bad country, mostrar selector';
                    showCountrySelector();
                } else {
                    setCountry(country);
                    analysis.decision = 'registrar en cookie y saltar';
                    jumpCallback(country);
                }
            });
        });
    }

    function setCountry(country) {
        document.cookie = 'country=' + country + ';';
    }

    function removeCountry() {
        document.cookie = 'country=ZZ; expires=Thu, 01 Jan 1970 00:00:00 GMT;';
    }

    function getCountry() {
        var cookie = document.cookie.split('country=');
        return (cookie.length < 2) ? false : cookie[1].split(';')[0];
    }

    return {
        setup: setup,
        dice: dice,
        setCountry: setCountry,
        removeCountry: removeCountry,
        analysis: analysis
    }

})();
