Vue.mixin({
    methods: {
        getImporte: function (value) {
            return new Intl.NumberFormat('es-AR', {style: 'currency', currency: "ARS"}).format(parseFloat(value));
        },
        getDate: function (date, format) {
            if (!format) {
                format = 'LLLL';
            }
            return moment(date).format(format);
        },
        getFromNow: function (date) {
            return moment(date).fromNow();
        },
        getIpl: function (ipl) {
            return parseInt(ipl * 100) + '%';
        },
        readHashVars: function () {
            var hash = location.hash;
            var hash = hash.replace('#', '');
            var array = hash.split('&');
            var data = {};
            for (var i in array) {
                var a = array[i];
                var sp = a.split('=');
                data[sp[0]] = sp[1];
            }
            return data;
        },
        getAuthHeaders: function () {
            var sesion = Cookies.get('sesion');
            if (sesion) {
                sesion = JSON.parse(sesion);
                return {auth: sesion.uuid + '@' + sesion.clienteId};
            } else {
                return false;
            }
        }
    }
});

String.prototype.slugify = function (separator = "-") {
    return this
        .toString()
        .normalize('NFD')                   // split an accented letter in the base letter and the acent
        .replace(/[\u0300-\u036f]/g, '')   // remove all previously split accents
        .toLowerCase()
        .trim()
        .replace(/[^a-z0-9 ]/g, '')   // remove all chars not letters, numbers and spaces (to be replaced)
        .replace(/\s+/g, separator);
};

Vue.directive('click-outside', {
    bind: function (el, binding, vnode) {
        this.event = function (event) {
            if (!(el == event.target || el.contains(event.target) || event.target.className === "select2-selection__choice__remove" || event.target.className === "select2-search__field")) {
                vnode.context[binding.expression](event);
            }
        };
        document.addEventListener('click', this.event)
    },
    unbind: function (el) {
        document.removeEventListener('click', this.event)
    },
});






$('.carousel').carousel();
$(document).ready(function () {
    $(document).on('scroll', function () {
        if ($(document).scrollTop() > 100) {
            $('#menu-fix').fadeIn();
        } else {
            $('#menu-fix').hide();
        }
    });
    $(document).scroll();
});
