Vue.component('lectuHeader', {
    props:
        {
            base: {
                type: String,
                default: "../"
            }
        },
    data: function () {
        return {
            user: null,
            data: {}
        }
    },
    methods: {
        populate: function () {
            function success(response) {
                this.data = response.body.usuario;
                Cookies.set('sesion', JSON.stringify(this.data), 365 * 999);
                this.updateUser();
            }

            function fail(error) {
                console.log(error);
            }

            var headers = this.getAuthHeaders();
            if (headers) {
                this.$http.get(URL_SERVICE + 'web/sesion', {headers}).then(success, fail);
            }
        },
        logonOpen: function () {
            this.$refs.logon.open();
        },
        updateUser: function () {
            var sesion = Cookies.get('sesion');
            if (sesion) {
                var usuario = JSON.parse(sesion);
                if (usuario.email) {
                    this.user = usuario.email;
                }
                this.data = usuario;
            } else {
                this.user = null;
            }
        },
        logout: function () {
            $('body').hide();

            function success(response) {
                Cookies.remove('sesion');
                this.updateUser();
                location.reload();
            }

            function fail(error) {
                Cookies.remove('sesion');
                this.updateUser();
                location.reload();
                console.log(error);
            }

            var headers = this.getAuthHeaders();
            if (headers) {
                this.$http.get(URL_SERVICE + 'web/cerrar/sesion', {headers}).then(success, fail);
            }
        }
    },
    mounted: function () {
        this.updateUser();
        this.populate();
    },
    template: `
<div class="">
     <logon ref="logon" :base="base"></logon>
     <div class="fluid-container " id="menu-fix" style="position: fixed; top: 0px; z-index: 10; width: 100%; display:none; background-color: rgba(252,252,252,.92);">
        <div class="container container-menuscrol">
            <lectu-menu :base="base"></lectu-menu>
        </div>
    </div>

    <div class="barra-color-resp"><span></span></div>

    <div class="container">
        <lectu-menu :base="base"></lectu-menu>
        <div class="row menu-res" style="display:none;">
            <div class="container">
                <div class="col-lg-12 contenido-menu-res">
                    <span>
                        <p>Suscripciones</p>
                        <p>Regalos</p>
                        <p>Nuestra Visión</p>
                        <p>¿Dudas?</p>
                    </span>
                </div>
            </div>
        </div>
    </div>
</div>
    `
});

Vue.component('lectuMenu', {
    props:
        {
            base: String
        },
    methods: {
        /*
        user: function () {
            console.log('user()');
            var sesion = Cookies.get('sesion');
            if (sesion) {
                var usuario = JSON.parse(sesion);
                return usuario.nombre + ' ' + usuario.apellido;
            } else {
                return "Mi Lecturita";
            }
        }*/
    },
    template: `
<div>
    <div class="row">
        <div class="d-xl-none d-lg-none col-lg-3 col-md-1 col-sm-2 col-2">
            <span class="menu-principal menu-burger" data-toggle="collapse" data-target="#burgermenucollapse">
                <span class="material-icons">
                    dehaze
                </span>
                <div class="collapse" id="burgermenucollapse">
                    <a :href="base+'#comofunciona'"><h5 class="m1">¿Cómo funciona?</h5></a><br>
                    <a :href="base+'unirse-new'"><h5 class="m2">&iexcl;Suscribite!</h5></a><br>
                    <a class="m4" style="text-decoration: none;" :href="base+'nuestra-vision'"><h5 class="m4">Nuestra Visión</h5></a><br>
                    <a class="m5" style="text-decoration: none;" :href="base+'dudas'"><h5>¿Dudas?</h5></a><br>
                </div>
            </span>
        </div>
        <div class="col-xl-2 col-lg-2 col-md-10 col-sm-8 col-8">
            <span class="menu-principal-logo">
                <a :href="base"><img :src="base+'assets/img/logo-lecturita.svg'" alt=""></a>
            </span>
            <span class="menu-principal-logo-responsive">
                <a :href="base"><img :src="base+'assets/img/logo-princ2.svg'" alt=""></a>
            </span>
        </div>
        <div class="col-xl-7 col-lg-8 d-lg-block d-md-none d-sm-none d-none">
            <span class="menu-principal" style="margin-left:-40px;">
                <a :href="base+'#comofunciona'"><h5 class="m1">¿Cómo funciona?</h5></a>
                <a :href="base+'unirse-new'"><h5 class="m2">&iexcl;Suscribite!</h5></a>
                <!--<a href="/regalos"><h5 class="m3">Regalos</h5></a>-->
                <a class="m4" style="text-decoration: none;" :href="base+'nuestra-vision'"><h5 class="m4">Nuestra Visión</h5></a>
                <a class="m5" style="text-decoration: none;" :href="base+'dudas'"><h5>¿Dudas?</h5></a>
            </span>
        </div>
        <div class="col-xl-3 col-lg-2 col-md-1 col-sm-2 col-2" v-if="false">
            <span class="menu-principal miperfil-menu">
                <a href="javascript:void(0);" @click="$parent.logonOpen" v-if="!$parent.user">
                    <div class="float-right">
                        <span class="login-emoji"></span>
                    </div>
                    <div class="miperfil-ingresar">
                        <h5>Mi Lecturita</h5>
                    </div>
                </a>
                
                <a :href="base+'miperfil'" v-if="$parent.user">
                    <div class="float-right">
                        <span class="login-emoji" :style="'background-image:url('+$parent.data.avatar.src+')'"></span>
                    </div>
                    <div class="miperfil-email" >
                        <h5>Mi Lecturita</h5>
                        <p>{{ $parent.user }}</p>
                    </div>
                </a>
            </span>
        </div>
    </div>
</div>
    
    `
});

Vue.component('logon', {
    props:
        {
            base: String
        },
    data: function () {
        return {
            isOpen: false,
            visible: 'menu'
        };
    },
    methods: {
        setVisible: function (visible) {
            this.visible = visible;
        },
        open: function () {
            this.isOpen = true;
            $('body').css('overflow', 'hidden');
            var self = this;
            $(document).bind('keydown', function (e) {
                if (e.which == 27) {
                    self.close();
                }
            });
        },
        close: function () {
            this.isOpen = false;
            $('body').css('overflow', 'auto');
            $(document).unbind('keydown');

            this.$parent.$forceUpdate();
            this.visible = "menu";
            this.$refs.login.reset();
            this.$refs.register.reset();
            this.$refs.recover.reset();
        }
    },
    template: `
<div class="logon" :class="{open: this.isOpen}">
    <div class="barra-color-resp"></div>
    <div class="container">
        <div class="row">
            <div class="col-xl-10 col-lg-10 col-md-10 col-sm-10 col-10">
                <div class="cerrar-layer">
                    <a href="javascript:void(0)"><img :src="base+'assets/img/3-iconos/cerrar.svg'" alt="" @click.stop="close"></a>
                </div>
            </div>
            <div class="col-xl-2 col-lg-2 col-md-2 col-sm-2 col-2">
                <span class="menu-principal miperfil-menu" style="padding-top:28px;">
                        <div class="float-right">
                            <span style="margin-top: -8px;" class="login-emoji"></span>
                        </div>
                        <div class="miperfil-ingresar">
                            <h5>Mi Lecturita</h5>
                        </div>
                </span>
            </div>
        </div>
    </div>
    <logon-menu v-show="visible == 'menu'"></logon-menu>
    <login v-show="visible == 'login'" ref="login" :base="base"></login>
    <register v-show="visible == 'register'" ref="register" :base="base"></register>
    <recover v-show="visible == 'recover'" ref="recover" :base="base"></recover>
</div>
    `
});

Vue.component('logon-menu', {
    template: `
     <div class="container">
        <div class="row modulo-base">
            <div class="col-xl-4"></div>
            <div class="col-xl-4">
                <div>
                    <span class="login-emoji emogi-grande"></span>
                    <br>
                    <br>
                </div>
                <div class="login-lecturita">
                    <span class="ingresar-login activado-log"><a href="javascript:void(0)" @click="$parent.setVisible('login')"><h1>Ingresar</h1></a><hr></span>
                    <span class="registrarse-login"><a href="javascript:void(0)" @click="$parent.setVisible('register')"><h1>Registrarse</h1><hr></a></span>
                </div>
            <div class="col-xl-4"></div>
            </div>
        </div>
    </div>
    
    `
});

Vue.component('login', {
    props:
        {
            base: String
        },
    data: function () {
        return {
            result: {},
            form: {
                email: null,
                password: null
            },
            sending: false
        }
    },
    methods: {
        send: function (e) {
            e.preventDefault();

            function success(response) {
                this.sending = false;
                this.result = response.body;
                switch (response.body.status) {
                    case "ok":
                        if (this.result.status == 'ok') {
                            Cookies.set('sesion', JSON.stringify(this.result.usuario), 365 * 999);
                            if (window.PasswordCredential) {
                                var c = new PasswordCredential(e.target);
                                navigator.credentials.store(c);
                            }

                            this.$parent.close();
                            appDemo.$refs.header.updateUser();

                        }
                        break;
                }
            }

            function fail(error) {
                if (error.status == 401) {
                    this.result = error.body;
                } else {
                    this.result.status = 'error';
                }
                this.sending = false;
            }

            var form = this.$refs.form;
            if (form.validateAll()) {
                this.sending = true;
                this.$http.post(URL_SERVICE + 'web/login', this.form).then(success, fail);
            }
        },
        reset: function () {
            Object.assign(this.$data, this.$options.data());
        }
    },
    template: `
   <div>
       <div class="container" style="display: block;">
        <div class="row margenes-login">
            <div class="col-xl-12">
                <span class="ingresar-ilustracion">
                    <img :src="base+'assets/img/2-ilustraciones/estrella.svg'" alt="">
                </span>
            </div>
            <div class="col-xl-5 col-md-12 col-xs-12 col-12">

                <div>
                    <span class="login-emoji emogi-grande"></span>
                    <br>
                </div>


                <span class="titulo-ingresar">
                    <h3>Mi Lecturita :)</h3>
                </span>
                
                <lct-form ref="form" method="post" :submit="send" id="login">
                    <div class="row padding-resp">
                        <div class="col-xl-12 col-lg-12 col-md-12 col-xs-12 col-12 co formulario-login">
                            <h6>Email</h6>
                            <lct-input placeholder="Email" type="text" name="email" v-model="form.email" autocomplete="username email" :rules="['required','email']"></lct-input>
                        </div>
                        
                        <div class="col-xl-12 col-lg-12 col-md-12 col-xs-12 col-12 formulario-login">
                            <h6>Contraseña</h6>
                            <lct-input placeholder="Contraseña" type="password" v-model="form.password" name="password" autocomplete="current-password" :rules="['required']"></lct-input>                       
                        </div>
                        
                        <div class="col-xl-12 col-lg-12 col-md-12 col-xs-12 col-12 formulario-login" v-if="result.status == 'error'" style="margin-top:15px;">
                            <div class="alert alert-danger">
                                Ocurrió un error inesperado. Vuelva a intentarlo.
                            </div>
                        </div>
                        
                        <div class="col-xl-12 col-lg-12 col-md-12 col-xs-12 col-12 formulario-login" v-if="result.status == 'fail'" style="margin-top:15px;">
                            <div class="alert alert-danger">
                                El email y/o contraseña son incorrectos.
                            </div>
                        </div>
                        
                         <div class="col-xl-12 col-lg-12 col-md-12 col-xs-12 col-12 formulario-login" v-if="result.status == 'ok'">
                            <div class="alert alert-success">
                                Enhorabuena! has ingresado!
                            </div>
                        </div>
                        
                        <div class="col-xl-12 col-lg-12 col-md-12 col-xs-12 col-12 formulario-login">
                            <p @click="$parent.setVisible('recover')">¿Olvidaste tu contraseña?</p>
                            <br>
                        </div>
                        
                       
                        <div class="col-xl-12">
                            <span class="gen-boton">
                                <button type="submit" :disabled="sending">
                                    <p v-if="!sending">Ingresar</p>
                                    <p v-if="sending">Ingresando...</p>
                                </button>
                            </span>
                            <p class="text-login">¿Todavía no tenés tu cuenta?<a href="javascript:void(0)" @click="$parent.setVisible('register')" style="color: #ee4043; text-decoration: none; font-weight: 700;"> Registrate acá</a></p>
                        </div>
                    </div>
                </lct-form>
                
            </div>
            <div class="col-xl-1">
            </div>

            <div class="col-xl-5" style="display: none;">
                <span class="titulo-ingresar ingresar-ilustracion">
                    <h3>También podés ingresar con:</h3>
                </span>
                <span class="formulario-login redes-sociales">
                    <h6>Logueate con tu red social.</h6>
                    <img :src="base+'assets/img/3-iconos/logo-facebook.svg'" alt="">
                    <img :src="base+'assets/img/3-iconos/logo-instagram.svg'" alt="">
                </span>
            </div>
        </div>
    </div>


<!------ Recuperar contraseña ------->

        <div class="container" style="display: none;">
            <div class="row">
                <div class="col-xl-5">
                    <span class="titulo-ingresar">
                        <br>
                        <h3>Recuperar contraseña.</h3>
                    </span>
                    <span class="formulario-login">
                        <h6>Email</h6>
                        <input placeholder="info@email.com" type="text">
                        <br>
                    </span>
    
                    <br>
                    <span class="gen-boton">
                        <button><p>Enviar</p></button>
                    </span>
                </div>
                <div class="col-xl-1">
                </div>
    
                <div class="col-xl-5" style="display: none;">
                    <span class="titulo-ingresar ingresar-ilustracion">
                        <h3>También podés ingresar con:</h3>
                    </span>
                    <span class="formulario-login redes-sociales">
                        <h6>Logueate con tu red social.</h6>
                        <img :src="base+'assets/img/3-iconos/logo-facebook.svg'" alt="">
                        <img :src="base+'assets/img/3-iconos/logo-instagram.svg'" alt="">
                    </span>
                </div>
            </div>
        </div>
    </div>
   `
});

Vue.component('register', {
    props:
        {
            base: String
        },
    data: function () {
        return {
            form: {
                nombre: null,
                apellido: null,
                email: null,
                password: null,
                passwordRepeat: null
            },
            result: {},
            sending: false
        };
    },
    methods: {
        send: function (e) {
            e.preventDefault();

            function success(response) {
                this.sending = false;
                if (response.body.status == 'ok') {
                    this.result = response.body;

                    Cookies.set('sesion', JSON.stringify(this.result.usuario), 365 * 999);


                    if (window.PasswordCredential) {
                        var c = new PasswordCredential(e.target);
                        navigator.credentials.store(c);
                    }

                    this.$parent.close();
                    appDemo.$refs.header.updateUser();
                }
            }

            function fail(error) {
                switch (error.status) {
                    case 401:
                        this.result = error.body;
                        break;
                }
                this.sending = false;
            }

            var form = this.$refs.form;
            if (form.validateAll()) {
                this.sending = true;
                this.$http.post(URL_SERVICE + 'web/registrar', this.form).then(success, fail);
            } else {
                this.result = {
                    status: 'error',
                    msg: 'Complete todos los campos del formulario'
                }
            }
        },
        reset: function () {
            Object.assign(this.$data, this.$options.data());
        },
        hasError: function () {
            var form = this.$refs.form;
            if (form) {
                return form.hasError();
            }
        }
    },
    template: `
   <div class="container">
        <div class="row margenes-login">
            <lct-form ref="form" method="post" :submit="send" id="register">
                <div class="col-xl-12">
                    <span class="ingresar-ilustracion">
                        <img :src="base+'assets/img/2-ilustraciones/libro.svg'" alt="">
                    </span>
                </div>
                <div class="col-xl-5">
                    <div>
                        <span class="login-emoji emogi-grande"></span>
                        <br>
                    </div>
    
                    <span class="titulo-ingresar">
                        <h3>Registrate y tené tu propio perfil :D</h3>
                    </span>
                    <div class="row padding-resp"> 
                        <span class="col-xl-6 formulario-login">
                            <h6>Nombre</h6>
                            <lct-input placeholder="Nombre" type="text" v-model="form.nombre" autocomplete="nombre name" name="name" :rules="['required']"></lct-input>
                        </span>
                        <span class="col-xl-6 formulario-login">
                            <h6>Apellido</h6>
                            <lct-input placeholder="Apellido" type="text" v-model="form.apellido" autocomplete="last_name apellido" name="lastname" :rules="['required']"></lct-input>
                        </span>
                        <span class="col-xl-12 formulario-login">
                            <h6>Email</h6>
                            <lct-input placeholder="Email" type="text" v-model="form.email" autocomplete="username" name="email" :rules="['required','email']"></lct-input>
                        </span>
                        <span class="col-xl-6 formulario-login">
                            <h6>Contraseña</h6>
                            <lct-input placeholder="Contraseña" type="password" v-model="form.password" autocomplete="current-password" name="password" :rules="['required','min:8']" ref="Contraseña"></lct-input>
                        </span>
                        <span class="col-xl-6 formulario-login">
                            <h6>Repetir Contraseña</h6>
                            <lct-input  placeholder="Repetir contraseña" type="password" v-model="form.passwordRepeat" name="password-repeat" :rules="['required','==:Contraseña']"></lct-input>
                        </span>
                    </div>
    
                    <br>
                       
                    <div class="alert alert-danger"  v-if="result.status == 'error'">
                        {{ result.msg }}
                    </div>                
                
                    <div class="alert alert-danger"  v-if="result.status == 'fail'">
                        El email y/o contraseña son incorrectos.
                    </div>
                 
                    <div class="alert alert-success" v-if="result.status == 'ok'">
                        Enhorabuena! has ingresado!
                    </div>
                        
                    <br>
                    <span class="gen-boton">
                        <button type="submit" :disabled="sending">
                             <p v-if="!sending">Registrar</p>
                             <p v-if="sending">Registrando...</p>
                        </button>
                    </span>
                   
                    <p class="text-login">¿Ya tenés tu usuario?<a href="javascript:void(0)" @click="$parent.setVisible('login')" style="color: #ee4043; text-decoration: none; font-weight: 700;"> Iniciá sesión acá</a></p>
                </div>
                <div class="col-xl-1">
                </div>
    
                <div class="col-xl-5" style="display: none;">
                    <span class="titulo-ingresar ingresar-ilustracion">
                        <h3>También podés registrarte:</h3>
                    </span>
                    <span class="formulario-login redes-sociales">
                        <h6>Logueate con tu red social.</h6>
                        <img :src="base+'assets/img/3-iconos/logo-facebook.svg'" alt="">
                        <img :src="base+'assets/img/3-iconos/logo-instagram.svg'" alt="">
                    </span>
                </div>
            </lct-form>
        </div>
    </div>
   `
});

Vue.component('recover', {
    props:
        {
            base: String
        },
    data: function () {
        return {
            result: {},
            form: {
                email: null,
                password: null
            },
            sending: false
        }
    },
    methods: {
        send: function (e) {
            e.preventDefault();

            function success(response) {
                this.sending = false;
                switch (response.body.status) {
                    case "ok":
                        this.result = response.body;
                        if (this.result.status == 'ok') {

                        }
                        break;
                }
            }

            function fail(error) {
                if (error.status == 401) {
                    this.result = error.body;
                } else {
                    this.result.status = 'error';
                }
                this.sending = false;
            }

            var form = this.$refs.form;
            if (form.validateAll()) {
                this.sending = true;
                this.$http.post(URL_SERVICE + 'web/recuperar/password', this.form).then(success, fail);
            }
        },
        reset: function () {
            Object.assign(this.$data, this.$options.data());
        }
    },
    template: `
   <div>
       <div class="container" style="display: block;">
        <div class="row margenes-login">
            <div class="col-xl-12">
                <span class="ingresar-ilustracion">
                    <img :src="base+'assets/img/2-ilustraciones/estrella.svg'" alt="">
                </span>
            </div>
            <div class="col-xl-5 col-md-12 col-xs-12 col-12">

                <div>
                    <span class="login-emoji emogi-grande"></span>
                    <br>
                </div>


                <span class="titulo-ingresar">
                    <h3>Recuperar Contraseña</h3>
                </span>
                <lct-form ref="form" method="post" :submit="send" id="recover">
                    <div class="row padding-resp">
                    
                        <div class="col-xl-12 col-lg-12 col-md-12 col-xs-12 col-12 co formulario-login" style="margin-bottom:20px;">
                            <h6>Ingrese su Email</h6>
                            <lct-input placeholder="Email" type="text" name="email" v-model="form.email" autocomplete="username email" :rules="['required','email']"></lct-input>
                        </div>                       
                        
                        <div class="col-xl-12 col-lg-12 col-md-12 col-xs-12 col-12 formulario-login" v-if="result.status == 'error'">
                            <div class="alert alert-danger">
                                <template v-if="result.msg">
                                    {{ result.msg }}
                                </template>
                                <template v-else>
                                    Ocurrió un error inesperado. Vuelva a intentarlo.
                                </template>
                            </div>
                        </div>
                        
                         <div class="col-xl-12 col-lg-12 col-md-12 col-xs-12 col-12 formulario-login" v-if="result.status == 'ok'">
                            <div class="alert alert-success">
                                Le hemos enviado un email con información para recuperar su contraseña.
                            </div>
                        </div>
                        
                       
                        <div class="col-xl-12" >
                            <span class="gen-boton">
                                <button type="submit" :disabled="sending" v-if="result.status != 'ok'">
                                    <p v-if="!sending">Enviar</p>
                                    <p v-if="sending">Enviando...</p>
                                </button>
                            </span>
                            <p class="text-login">¿Todavía no tenés tu cuenta?<a href="javascript:void(0)" @click="$parent.setVisible('register')" style="color: #ee4043; text-decoration: none; font-weight: 700;"> Registrate acá</a></p>
                        </div>
                    </div>
                </lct-form>
            </div>
            <div class="col-xl-1">
            </div>

            <div class="col-xl-5" style="display: none;">
                <span class="titulo-ingresar ingresar-ilustracion">
                    <h3>También podés ingresar con:</h3>
                </span>
                <span class="formulario-login redes-sociales">
                    <h6>Logueate con tu red social.</h6>
                    <img :src="base+'assets/img/3-iconos/logo-facebook.svg'" alt="">
                    <img :src="base+'assets/img/3-iconos/logo-instagram.svg'" alt="">
                </span>
            </div>
        </div>
    </div>


<!------ Recuperar contraseña ------->

        <div class="container" style="display: none;">
        <div class="row">
            <div class="col-xl-5">
                <span class="titulo-ingresar">
                    <br>
                    <h3>Recuperar contraseña.</h3>
                </span>
                <span class="formulario-login">
                    <h6>Email</h6>
                    <input placeholder="info@email.com" type="text">
                    <br>
                </span>

                <br>
                <span class="gen-boton">
                    <button><p>Enviar</p></button>
                </span>
            </div>
            <div class="col-xl-1">
            </div>

            <div class="col-xl-5" style="display: none;">
                <span class="titulo-ingresar ingresar-ilustracion">
                    <h3>También podés ingresar con:</h3>
                </span>
                <span class="formulario-login redes-sociales">
                    <h6>Logueate con tu red social.</h6>
                    <img :src="base+'assets/img/3-iconos/logo-facebook.svg'" alt="">
                    <img :src="base+'assets/img/3-iconos/logo-instagram.svg'" alt="">
                </span>
            </div>
        </div>
    </div>
    </div>
   `
});
