Vue.component('logon', {
    data: function () {
        return {
            isOpen: false,
            visible: 'menu'
        };
    },
    methods: {
        setVisible: function (visible) {
            this.visible = visible;
        },
        open: function () {
            this.isOpen = true;
            $('body').css('overflow', 'hidden');
            var self = this;
            $(document).bind('keydown', function (e) {
                if (e.which == 27) {
                    self.close();
                }
            });
        },
        close: function () {
            this.isOpen = false;
            $('body').css('overflow', 'auto');
            $(document).unbind('keydown');
        }
    },
    template: `
<div class="logon" :class="{open: this.isOpen}">
    <div class="barra-color-resp"></div>
    <div class="container">
        <div class="row">
            <div class="col-xl-10 col-lg-10 col-md-10 col-sm-10 col-10">
                <div class="cerrar-layer">
                    <a href="javascript:void(0)"><img src="/assets/img/3-iconos/cerrar.svg" alt="" @click.stop="close"></a>
                </div>
            </div>
            <div class="col-xl-2 col-lg-2 col-md-2 col-sm-2 col-2">
                <span class="menu-principal miperfil-menu">
                    <a><span class="login-emoji"></span>
                    <h5>Mi Lecturita</h5></a>
                </span>
            </div>
        </div>
    </div>
    <logon-menu v-show="visible == 'menu'"></logon-menu>
    <login v-show="visible == 'login'"></login>
    <register v-show="visible == 'register'"></register>
</div>
    `
});

Vue.component('logon-menu', {
    template: `
     <div class="container">
        <div class="row modulo-base">
            <div class="col-xl-4"></div>
            <div class="col-xl-4">
                <div>
                    <span class="login-emoji emogi-grande"></span>
                    <br>
                    <br>
                </div>
                <div class="login-lecturita">
                    <span class="ingresar-login activado-log"><a href="javascript:void(0)" @click="$parent.setVisible('login')"><h1>Ingresar</h1></a><hr></span>
                    <span class="registrarse-login"><a href="javascript:void(0)" @click="$parent.setVisible('register')"><h1>Registrarse</h1><hr></a></span>
                </div>
            <div class="col-xl-4"></div>
            </div>
        </div>
    </div>
    
    `
});

Vue.component('login', {
    data: function () {
        return {
            result: {},
            form: {
                email: null,
                password: null
            },
            sending: false
        }
    },
    methods: {
        send: function (e) {
            e.preventDefault();

            function success(response) {
                this.sending = false;
                switch (response.body.status) {
                    case "ok":
                    case "fail":
                        this.result = response.body;
                        if (this.result.status == 'ok') {
                            Cookies.set('sesion', JSON.stringify(this.result.usuario));
                            console.log(Cookies.get('sesion'));

                            if (window.PasswordCredential) {
                                var c = new PasswordCredential(e.target);
                                navigator.credentials.store(c);
                            } else {
                                Promise.resolve(profile);
                            }

                            this.$parent.close();

                        }
                        break;
                }
            }

            function fail(error) {
                this.sending = false;
            }

            this.sending = true;
            this.$http.post(URL_SERVICE + 'web/login', this.form).then(success, fail);
        }
    },
    template: `
   <div>
       <div class="container" style="display: block;">
        <div class="row margenes-login">
            <div class="col-xl-12">
                <span class="ingresar-ilustracion">
                    <img src="/assets/img/2-ilustraciones/estrella.svg" alt="">
                </span>
            </div>
            <div class="col-xl-5 col-md-12 col-xs-12 col-12">

                <div>
                    <span class="login-emoji emogi-grande"></span>
                    <br>
                </div>


                <span class="titulo-ingresar">
                    <h3>Mi Lecturita :)</h3>
                </span>
                <form id="login" method="post" @submit="send">
                    <div class="row padding-resp">
                        <div class="col-xl-12 col-lg-12 col-md-12 col-xs-12 col-12 co formulario-login">
                            <h6>Email</h6>
                            <input placeholder="Email" type="text" name="email" v-model="form.email" autocomplete="username email">
                        </div>
                        
                        <div class="col-xl-12 col-lg-12 col-md-12 col-xs-12 col-12 formulario-login">
                            <h6>Contraseña</h6>
                            <input placeholder="Contraseña" type="password" v-model="form.password" name="password" autocomplete="current-password">                       
                        </div>
                        <div class="col-xl-12 col-lg-12 col-md-12 col-xs-12 col-12 formulario-login" v-if="result.status == 'fail'">
                            <div class="alert alert-danger">
                                El email y/o contraseña son incorrectos.
                            </div>
                        </div>
                        
                         <div class="col-xl-12 col-lg-12 col-md-12 col-xs-12 col-12 formulario-login" v-if="result.status == 'ok'">
                            <div class="alert alert-success">
                                Enhorabuena! has ingresado!
                            </div>
                        </div>
                        
                        <div class="col-xl-12 col-lg-12 col-md-12 col-xs-12 col-12 formulario-login">
                            <p>¿Olvidaste tu contraseña?</p>
                            <br>
                        </div>
                        
                       
                        <div class="col-xl-12">
                            <span class="gen-boton">
                                <button type="submit" :disabled="sending">
                                    <p v-if="!sending">Ingresar</p>
                                    <p v-if="sending">Ingresando...</p>
                                </button>
                            </span>
                            <p class="text-login">¿Todavía no tenés tu cuenta?<a href="javascript:void(0)" @click="$parent.setVisible('register')" style="color: #ee4043; text-decoration: none; font-weight: 700;"> Registrate acá</a></p>
                        </div>
                    </div>
                </form>
            </div>
            <div class="col-xl-1">
            </div>

            <div class="col-xl-5" style="display: none;">
                <span class="titulo-ingresar ingresar-ilustracion">
                    <h3>También podés ingresar con:</h3>
                </span>
                <span class="formulario-login redes-sociales">
                    <h6>Logueate con tu red social.</h6>
                    <img src="/assets/img/3-iconos/logo-facebook.svg" alt="">
                    <img src="/assets/img/3-iconos/logo-instagram.svg" alt="">
                </span>
            </div>
        </div>
    </div>


<!------ Recuperar contraseña ------->

        <div class="container" style="display: none;">
        <div class="row">
            <div class="col-xl-5">
                <span class="titulo-ingresar">
                    <br>
                    <h3>Recuperar contraseña.</h3>
                </span>
                <span class="formulario-login">
                    <h6>Email</h6>
                    <input placeholder="info@email.com" type="text">
                    <br>
                </span>

                <br>
                <span class="gen-boton">
                    <button><p>Enviar</p></button>
                </span>
            </div>
            <div class="col-xl-1">
            </div>

            <div class="col-xl-5" style="display: none;">
                <span class="titulo-ingresar ingresar-ilustracion">
                    <h3>También podés ingresar con:</h3>
                </span>
                <span class="formulario-login redes-sociales">
                    <h6>Logueate con tu red social.</h6>
                    <img src="/assets/img/3-iconos/logo-facebook.svg" alt="">
                    <img src="/assets/img/3-iconos/logo-instagram.svg" alt="">
                </span>
            </div>
        </div>
    </div>
    </div>
   `
});

Vue.component('register', {
    template: `
   <div class="container">
        <div class="row margenes-login">
            <div class="col-xl-12">
                <span class="ingresar-ilustracion">
                    <img src="/assets/img/2-ilustraciones/libro.svg" alt="">
                </span>
            </div>
            <div class="col-xl-5">
                <div>
                    <span class="login-emoji emogi-grande"></span>
                    <br>
                </div>

                <span class="titulo-ingresar">
                    <h3>Registrate y tené tu propio perfil :D</h3>
                </span>
                <div class="row padding-resp">
                    <span class="col-xl-6 formulario-login">
                        <h6>Nombre</h6>
                        <input placeholder="Nombre" type="text">
                    </span>
                    <span class="col-xl-6 formulario-login">
                        <h6>Apellido</h6>
                        <input placeholder="Apellido" type="text">
                    </span>
                    <span class="col-xl-12 formulario-login">
                        <h6>Email</h6>
                        <input placeholder="Email" type="text">
                    </span>
                    <span class="col-xl-6 formulario-login">
                        <h6>Contraseña</h6>
                        <input  placeholder="Contraseña" type="password">
                    </span>
                    <span class="col-xl-6 formulario-login">
                        <h6>Repetir Contraseña</h6>
                        <input  placeholder="Repetir contraseña" type="password">
                    </span>
                </div>

                <br>
                <br>
                <span class="gen-boton">
                    <button @click="$parent.setVisible('register')"><p>Registrar</p></button>
                </span>
                <p class="text-login">¿Ya tenés tu usuario?<a href="javascript:void(0)" @click="$parent.setVisible('login')" style="color: #ee4043; text-decoration: none; font-weight: 700;"> Iniciá sesión acá</a></p>
            </div>
            <div class="col-xl-1">
            </div>

            <div class="col-xl-5" style="display: none;">
                <span class="titulo-ingresar ingresar-ilustracion">
                    <h3>También podés registrarte:</h3>
                </span>
                <span class="formulario-login redes-sociales">
                    <h6>Logueate con tu red social.</h6>
                    <img src="/assets/img/3-iconos/logo-facebook.svg" alt="">
                    <img src="/assets/img/3-iconos/logo-instagram.svg" alt="">
                </span>
            </div>
        </div>
    </div>
   `
});